import { Client } from 'pg';
//
import IKDB from './../Prototype/IKDB';
//
export default class IKDB_SQL extends IKDB {
  constructor(config) {
    super(config)
    if (config && config.database) { console.debug(`Using database: ${config.database} with config: ${config}`); }
    this.database = config.database;
  }
  //Overwrites
  async connect() { return await (await this._getConnection()).connect(); }
  async cleanup() { return await (await this._getConnection()).end(); }
  async beginTransaction() { return await (await this._getConnection()).query('START TRANSACTION'); }
  async commit() { return await (await this._getConnection()).query('COMMIT'); }
  async rollback() { return await (await this._getConnection()).query('ROLLBACK'); }
  async runQuery(qry) { return await qry.run(await this._getConnection()); }
  //Public 
  async sanitize(val) { return (await this._getConnection()).getClient().escape(val); }

  /* private */
  async _getConnection() {
    if (!this.MYSQL_CONNECTION) this.MYSQL_CONNECTION = await this._newConnection(this.config);
    return this.MYSQL_CONNECTION;
  }
  _newConnection(config) {
    return new Promise((resolve, reject) => {
      const conn = new Client({
          host: config.host, database: config.database,
          port: config.port, user: config.user,
          password: config.password
      });
      resolve(conn);
    });
  }
}
